/**
 * Define a locale object.
 * @function load
 */
'use strict';

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var evaljson = require('evaljson');

var inflection = require('inflection');
var stringcase = require('stringcase');

/** @lends load */
function load(src) {
  /**
   * Locale instance.
   * @param {string} keypath - Keypath of message resource.
   * @param {Object} options - optional settings.
   * @param {Object} options.vars - Dynamic variables.
   * @returns {?string} - Message
   */
  function l(keypath, options) {
    options = options || {};
    var $vars = l.$vars;
    l.$vars = options.vars || {};
    var result = l;
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = String(keypath).split('.')[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var key = _step.value;

        result = result && result[key];
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    delete l.$vars;
    // noinspection Eslint
    l.__proto__.$vars = $vars; // Restore $vars

    return result;
  }

  // noinspection Eslint
  l.__proto__ = Object.assign(new Function(''), {
    $vars: {},
    $fallback: {},
    fallback: function fallback(locale) {
      // noinspection Eslint
      l.__proto__.$fallback = locale;
    },
    toJSON: function toJSON() {
      return Object.assign({}, l);
    }
  });

  var properties = Object.keys(src || {}).reduce(function (properties, name) {
    return Object.assign(properties, _defineProperty({}, name, {
      get: function get() {
        var $vars = l.$vars;
        var $fallback = l.$fallback;

        var value = src[name];
        if (typeof value === 'undefined') {
          value = $fallback && $fallback[name];
        }
        var context = load.context;
        return evaljson(value, context, src, { l: l, vars: $vars });
      },

      enumerable: true
    }));
  }, {});
  Object.defineProperties(l, properties);
  return l;
}

Object.assign(load, {
  context: Object.assign({}, stringcase, inflection)
});

module.exports = load;
//# sourceMappingURL=data:application/json;base64,bnVsbA==